Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustBeLargerThanToleranceLineRule.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustBeLargerThanToleranceLineRule.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustBeLargerThanToleranceLineRule.java	(revision 727)
@@ -69,14 +69,6 @@
     
     public MustBeLargerThanToleranceLineRule( 
             TopologyPlan plan,
-            TopologyRuleFactory factory
-    ) {
-        super(plan, factory);
-        this.actions.add(new DeleteAction());
-    }
-    
-    public MustBeLargerThanToleranceLineRule( 
-            TopologyPlan plan,
             TopologyRuleFactory factory,
             double tolerance,
             String dataSet1,
@@ -91,8 +83,8 @@
     public void check(SimpleTaskStatus taskStatus, TopologyReport report, Feature feature) throws Exception {
         Geometry geom = feature.getDefaultGeometry();
         if( geom.perimeter()<this.getTolerance() ) {
-            report.addLine(this, this.getDataSet1(), null, 
-                    geom, feature.getReference(), null, false, 
+            report.addLine(this, this.getDataSet1(), null,
+                    geom, null, feature.getReference(), null, false, 
                     "The length of the line is less than the specified tolerance"
             );
         }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsPointRuleFactory.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsPointRuleFactory.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsPointRuleFactory.java	(revision 727)
@@ -58,9 +58,4 @@
         return rule;
     }    
 
-    @Override
-    public TopologyRule createRule(TopologyPlan plan) {
-        TopologyRule rule = new ContainsPointRule(plan, this);
-        return rule;
-    }
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsNullRuleFactory.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsNullRuleFactory.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsNullRuleFactory.java	(revision 727)
@@ -55,9 +55,4 @@
         return rule;
     }    
 
-    @Override
-    public TopologyRule createRule(TopologyPlan plan) {
-        TopologyRule rule = new ContainsNullRule(plan, this);
-        return rule;
-    }
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustNotOverlapPolygonRuleFactory.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustNotOverlapPolygonRuleFactory.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustNotOverlapPolygonRuleFactory.java	(revision 727)
@@ -56,9 +56,4 @@
         return rule;
     }    
 
-    @Override
-    public TopologyRule createRule(TopologyPlan plan) {
-        TopologyRule rule = new MustNotOverlapPolygonRule(plan, this);
-        return rule;
-    }
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/PointMustBeProperlyInsidePolygonRuleFactory.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/PointMustBeProperlyInsidePolygonRuleFactory.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/PointMustBeProperlyInsidePolygonRuleFactory.java	(revision 727)
@@ -58,9 +58,4 @@
         return rule;
     }    
 
-    @Override
-    public TopologyRule createRule(TopologyPlan plan) {
-        TopologyRule rule = new PointMustBeProperlyInsidePolygonRule(plan, this);
-        return rule;
-    }
 }
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustBeLargerThanToleranceLineRuleFactory.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustBeLargerThanToleranceLineRuleFactory.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustBeLargerThanToleranceLineRuleFactory.java	(revision 727)
@@ -49,12 +49,6 @@
     }
     
     @Override
-    public TopologyRule createRule(TopologyPlan plan) {
-        TopologyRule rule = new MustBeLargerThanToleranceLineRule(plan, this);
-        return rule;
-    }
-    
-    @Override
     public TopologyRule createRule(TopologyPlan plan, String dataSet1, String dataSet2, double tolerance) {
         TopologyRule rule = new MustBeLargerThanToleranceLineRule(plan, this, tolerance, dataSet1, dataSet2);
         return rule;
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsPointRule.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsPointRule.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsPointRule.java	(revision 727)
@@ -34,7 +34,6 @@
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.fmap.geom.Geometry;
 import org.gvsig.fmap.geom.primitive.Point;
-import org.gvsig.fmap.geom.primitive.Polygon;
 import org.gvsig.tools.dynobject.DynObject;
 import org.gvsig.tools.task.SimpleTaskStatus;
 import org.gvsig.topology.lib.spi.AbstractTopologyRule;
@@ -92,14 +91,6 @@
 
     public ContainsPointRule(
             TopologyPlan plan,
-            TopologyRuleFactory factory
-    ) {
-        super(plan, factory);
-        this.actions.add(new CreateFetureAction());
-    }
-
-    public ContainsPointRule(
-            TopologyPlan plan,
             TopologyRuleFactory factory,
             double tolerance,
             String dataSet1,
@@ -114,7 +105,7 @@
     protected void check(SimpleTaskStatus taskStatus, TopologyReport report, Feature feature1) throws Exception {
         FeatureSet set = null;
         try {
-            FeatureStore store2 = this.getDataSet2().getStore();
+            FeatureStore store2 = this.getDataSet2().getFeatureStore();
             if (this.expression == null) {
                 ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
                 this.expression = manager.createExpression();
@@ -124,19 +115,21 @@
             Geometry polygon = feature1.getDefaultGeometry();
             TopologyDataSet theDataSet = this.getDataSet2();
             if (theDataSet.getSpatialIndex() != null) {
-                boolean ok = false;
+                boolean contains = false;
                 for (FeatureReference featureReference : theDataSet.query(polygon)) {
                     Feature feature2 = featureReference.getFeature();
-                    if( polygon.contains(feature2.getDefaultGeometry()) ) {
-                        ok = true;
+                    Geometry otherPoint = feature2.getDefaultGeometry();
+                    if( otherPoint!=null && polygon.contains(otherPoint) ) {
+                        contains = true;
                         break;
                     }
                 }
-                if( !ok ) {
+                if( !contains ) {
                     report.addLine(this,
                             this.getDataSet1(),
                             this.getDataSet2(),
                             polygon,
+                            polygon,
                             feature1.getReference(),
                             null,
                             false,
@@ -159,6 +152,7 @@
                             this.getDataSet1(),
                             this.getDataSet2(),
                             polygon,
+                            polygon,
                             feature1.getReference(),
                             null,
                             false,
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsNullRule.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsNullRule.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/ContainsNullRule.java	(revision 727)
@@ -40,13 +40,6 @@
 
     public ContainsNullRule(
             TopologyPlan plan,
-            TopologyRuleFactory factory
-    ) {
-        super(plan, factory);
-    }
-    
-    public ContainsNullRule(
-            TopologyPlan plan,
             TopologyRuleFactory factory,
             double tolerance,
             String dataSet1,
@@ -64,6 +57,7 @@
                         this.getDataSet1(),
                         this.getDataSet2(),
                         feature1.getDefaultGeometry(),
+                        null,
                         feature1.getReference(),
                         null,
                         false,
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustNotOverlapPolygonRule.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustNotOverlapPolygonRule.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/MustNotOverlapPolygonRule.java	(revision 727)
@@ -134,16 +134,6 @@
 
     public MustNotOverlapPolygonRule(
             TopologyPlan plan,
-            TopologyRuleFactory factory
-    ) {
-        super(plan, factory);
-        this.addAction(new CreateFetureAction());
-        this.addAction(new MergeAction());
-        this.addAction(new SubtractAction());
-    }
-
-    public MustNotOverlapPolygonRule(
-            TopologyPlan plan,
             TopologyRuleFactory factory,
             double tolerance,
             String dataSet1
@@ -174,11 +164,14 @@
                         continue;
                     }
                     Feature feature = reference.getFeature();
-                    if (polygon.overlaps(feature.getDefaultGeometry())) {
+                    Geometry otherPolygon = feature.getDefaultGeometry();
+                    if (otherPolygon!=null && polygon.overlaps(otherPolygon)) {;
+                        Geometry error = otherPolygon.difference(polygon);
                         report.addLine(this,
                                 theDataSet,
                                 null,
                                 polygon,
+                                error,
                                 feature1.getReference(),
                                 null,
                                 false,
@@ -198,11 +191,18 @@
                                 )
                         ).toString()
                 );
-                if (theDataSet.findFirst(this.expression) != null) {
+                Feature feature = theDataSet.findFirst(this.expression);
+                if ( feature != null) {
+                    Geometry otherPolygon = feature.getDefaultGeometry();
+                    Geometry error = null;
+                    if( otherPolygon!=null ) {
+                        error = polygon.difference(otherPolygon);
+                    }
                     report.addLine(this,
                             theDataSet,
                             null,
                             polygon,
+                            error,
                             feature1.getReference(),
                             null,
                             false,
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/PointMustBeProperlyInsidePolygonRule.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/PointMustBeProperlyInsidePolygonRule.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.impl/src/main/java/org/gvsig/topology/rule/PointMustBeProperlyInsidePolygonRule.java	(revision 727)
@@ -82,14 +82,6 @@
 
     public PointMustBeProperlyInsidePolygonRule(
             TopologyPlan plan,
-            TopologyRuleFactory factory
-    ) {
-        super(plan, factory);
-        this.actions.add(new DeleteAction());
-    }
-
-    public PointMustBeProperlyInsidePolygonRule(
-            TopologyPlan plan,
             TopologyRuleFactory factory,
             double tolerance,
             String dataSet1,
@@ -104,7 +96,7 @@
     protected void check(SimpleTaskStatus taskStatus, TopologyReport report, Feature feature1) throws Exception {
         FeatureSet set = null;
         try {
-            FeatureStore store2 = this.getDataSet2().getStore();
+            FeatureStore store2 = this.getDataSet2().getFeatureStore();
             if (this.expression == null) {
                 ExpressionEvaluatorManager manager = ExpressionEvaluatorLocator.getManager();
                 this.expression = manager.createExpression();
@@ -113,32 +105,34 @@
             }
             Geometry point = feature1.getDefaultGeometry();
             TopologyDataSet theDataSet = this.getDataSet2();
-//            if (theDataSet.getSpatialIndex() != null) {
-//                boolean ok = false;
-//                for (FeatureReference featureReference : theDataSet.query(point)) {
-//                    Feature feature2 = featureReference.getFeature();
-//                    if( feature2.getDefaultGeometry().overlaps(point) ) {
-//                        ok = true;
-//                        break;
-//                    }
-//                }
-//                if( !ok ) {
-//                    report.addLine(this,
-//                            this.getDataSet1(),
-//                            this.getDataSet2(),
-//                            point,
-//                            feature1.getReference(),
-//                            null,
-//                            false,
-//                            "The point are error where are not inside a polygon."
-//                    );
-//                }
-//            } else {
+            if (theDataSet.getSpatialIndex() != null) {
+                boolean contained = false;
+                for (FeatureReference featureReference : theDataSet.query(point)) {
+                    Feature feature2 = featureReference.getFeature();
+                    Geometry otherPolygon = feature2.getDefaultGeometry();
+                    if( otherPolygon!=null && otherPolygon.contains(point) ) {
+                        contained = true;
+                        break;
+                    }
+                }
+                if( !contained ) {
+                    report.addLine(this,
+                            this.getDataSet1(),
+                            this.getDataSet2(),
+                            point,
+                            point,
+                            feature1.getReference(),
+                            null,
+                            false,
+                            "The point are error where are not inside a polygon."
+                    );
+                }
+            } else {
                 this.expression.setPhrase(
                         this.expressionBuilder.ifnull(
                                 this.expressionBuilder.column(this.geomName),
                                 this.expressionBuilder.constant(false),
-                                this.expressionBuilder.ST_Overlaps(
+                                this.expressionBuilder.ST_Contains(
                                         this.expressionBuilder.column(this.geomName),
                                         this.expressionBuilder.geometry(point)
                                 )
@@ -149,13 +143,14 @@
                             this.getDataSet1(),
                             this.getDataSet2(),
                             point,
+                            point,
                             feature1.getReference(),
                             null,
                             false,
                             "The point are error where are not inside a polygon."
                     );
                 }
-//            }
+            }
         } catch (Exception ex) {
             LOGGER.warn("Can't check feature.", ex);
         } finally {
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyRuleFactory.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyRuleFactory.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyRuleFactory.java	(revision 727)
@@ -44,8 +44,6 @@
     
     public TopologyRule createRule(TopologyPlan plan, String dataSet1, String dataSet2, double tolerance);
 
-    public TopologyRule createRule(TopologyPlan plan);
-
     public boolean hasSecondaryDataSet();
 
     public boolean canApplyToDataSet(TopologyDataSet dataSet);
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyManager.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyManager.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyManager.java	(revision 727)
@@ -24,7 +24,7 @@
 package org.gvsig.topology.lib.api;
 
 import java.util.List;
-import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.DataStore;
 
 /**
  *
@@ -42,7 +42,7 @@
 
     public void addRuleFactories(TopologyRuleFactory factory);
 
-    public TopologyDataSet createDataSet(String name, FeatureStore store);
+    public TopologyDataSet createDataSet(String name, DataStore store);
     
     public void setDefaultServices(TopologyServices services);
 
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyReport.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyReport.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyReport.java	(revision 727)
@@ -44,6 +44,7 @@
             TopologyDataSet dataSet1,
             TopologyDataSet dataSet2,
             Geometry geometry,
+            Geometry error,
             FeatureReference feature1,
             FeatureReference feature2,
             boolean exception,
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyReportLine.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyReportLine.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyReportLine.java	(revision 727)
@@ -40,6 +40,8 @@
     
     public Geometry getGeometry();
     
+    public Geometry getError();
+    
     public FeatureReference getFeature1();
 
     public FeatureReference getFeature2();
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyDataSet.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyDataSet.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyDataSet.java	(revision 727)
@@ -24,6 +24,7 @@
 package org.gvsig.topology.lib.api;
 
 import org.gvsig.expressionevaluator.Expression;
+import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.exception.DataException;
 import org.gvsig.fmap.dal.feature.EditableFeature;
 import org.gvsig.fmap.dal.feature.Feature;
@@ -49,8 +50,10 @@
 
     public String getName();
     
-    public FeatureStore getStore();
+    public DataStore getStore();
 
+    public FeatureStore getFeatureStore();
+
     public boolean isThisStore(FeatureStore featureStore);
 
     public int getGeometryType() ;
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyPlan.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyPlan.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/api/TopologyPlan.java	(revision 727)
@@ -24,6 +24,7 @@
 package org.gvsig.topology.lib.api;
 
 import java.util.Collection;
+import org.gvsig.fmap.dal.DataStore;
 import org.gvsig.fmap.dal.feature.FeatureStore;
 import org.gvsig.tools.task.SimpleTaskStatus;
 
@@ -52,7 +53,7 @@
     
     public void execute();
     
-    public TopologyDataSet addDataSet(String name, FeatureStore store);
+    public TopologyDataSet addDataSet(String name, DataStore store);
 
     public TopologyDataSet addDataSet(TopologyDataSet dataSet);
     
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/spi/AbstractTopologyRule.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/spi/AbstractTopologyRule.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.lib/org.gvsig.topology.lib.api/src/main/java/org/gvsig/topology/lib/spi/AbstractTopologyRule.java	(revision 727)
@@ -56,34 +56,21 @@
     private String dataSet1;
     private String dataSet2;
 
-//    protected TopologyReport report;
     protected List<TopologyRuleAction> actions;
 
     protected AbstractTopologyRule(
             TopologyPlan plan,
-            TopologyRuleFactory factory
-    ) {
-        this.plan = plan;
-        this.factory = factory;
-
-        this.tolerance = plan.getTolerance();
-        this.dataSet1 = null;
-        this.dataSet2 = null;
-//        this.report = null;
-        this.actions = new ArrayList<>();
-    }
-    
-    protected AbstractTopologyRule(
-            TopologyPlan plan,
             TopologyRuleFactory factory,
             double tolerance,
             String dataSet1,
             String dataSet2
     ) {
-        this(plan,factory);
+        this.plan = plan;
+        this.factory = factory;
         this.tolerance = tolerance;
         this.dataSet1 = dataSet1;
         this.dataSet2 = dataSet2;
+        this.actions = new ArrayList<>();
     }
 
     protected AbstractTopologyRule(
Index: org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyPlanPropertiesView.java
===================================================================
--- org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyPlanPropertiesView.java	(revision 726)
+++ org.gvsig.topology/trunk/org.gvsig.topology/org.gvsig.topology.swing/org.gvsig.topology.swing.impl/src/main/java/org/gvsig/topology/swing/impl/DefaultJTopologyPlanPropertiesView.java	(revision 727)
@@ -31,6 +31,7 @@
    JList lstRules = new JList();
    JButton btnAddRule = new JButton();
    JButton btnRemoveRule = new JButton();
+   JButton btnEditRule = new JButton();
    JLabel lblTolerance = new JLabel();
    JTextField txtTolerance = new JTextField();
 
@@ -178,14 +179,14 @@
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
 
-      btnAddDataSet.setIcon(loadImage("org/gvsig/topology/swing/impl/images/dataset_add.png"));
+      btnAddDataSet.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-plan-dataset-add.png"));
       btnAddDataSet.setName("btnAddDataSet");
       btnAddDataSet.setToolTipText("_Add_dataset");
       EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
       btnAddDataSet.setBorder(emptyborder1);
       jpanel1.add(btnAddDataSet,cc.xy(6,1));
 
-      btnRemoveDataSet.setIcon(loadImage("org/gvsig/topology/swing/impl/images/dataset_remove.png"));
+      btnRemoveDataSet.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-plan-dataset-remove.png"));
       btnRemoveDataSet.setName("btnRemoveDataSet");
       btnRemoveDataSet.setToolTipText("_Remove_dataset");
       EmptyBorder emptyborder2 = new EmptyBorder(2,2,2,2);
@@ -218,25 +219,32 @@
    public JPanel createPanel4()
    {
       JPanel jpanel1 = new JPanel();
-      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
+      FormLayout formlayout1 = new FormLayout("FILL:DEFAULT:GROW(1.0),FILL:DEFAULT:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE,FILL:4DLU:NONE,FILL:DEFAULT:NONE","CENTER:DEFAULT:NONE");
       CellConstraints cc = new CellConstraints();
       jpanel1.setLayout(formlayout1);
 
-      btnAddRule.setIcon(loadImage("org/gvsig/topology/swing/impl/images/rule_add.png"));
+      btnAddRule.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-plan-rule-add.png"));
       btnAddRule.setName("btnAddRule");
       btnAddRule.setToolTipText("_Add_rule");
       EmptyBorder emptyborder1 = new EmptyBorder(2,2,2,2);
       btnAddRule.setBorder(emptyborder1);
-      jpanel1.add(btnAddRule,cc.xy(5,1));
+      jpanel1.add(btnAddRule,cc.xy(7,1));
 
-      btnRemoveRule.setIcon(loadImage("org/gvsig/topology/swing/impl/images/rule_remove.png"));
+      btnRemoveRule.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-plan-rule-remove.png"));
       btnRemoveRule.setName("btnRemoveRule");
       btnRemoveRule.setToolTipText("_Remove_rule");
       EmptyBorder emptyborder2 = new EmptyBorder(2,2,2,2);
       btnRemoveRule.setBorder(emptyborder2);
       jpanel1.add(btnRemoveRule,cc.xy(3,1));
 
-      addFillComponents(jpanel1,new int[]{ 1,2,4 },new int[]{ 1 });
+      btnEditRule.setIcon(loadImage("org/gvsig/topology/swing/impl/images/topology-plan-rule-edit.png"));
+      btnEditRule.setName("btnEditRule");
+      btnEditRule.setToolTipText("_Edit_rule");
+      EmptyBorder emptyborder3 = new EmptyBorder(2,2,2,2);
+      btnEditRule.setBorder(emptyborder3);
+      jpanel1.add(btnEditRule,cc.xy(5,1));
+
+      addFillComponents(jpanel1,new int[]{ 1,2,4,6 },new int[]{ 1 });
       return jpanel1;
    }
 
